#include <GDIPlus.au3>
#include <Misc.au3>

Opt("GUIOnEventMode", 1)
Opt("MouseCoordMode", 2)

Global Const $width = 600, $height = 400 ; Modifiez comme bon vous semble
Global $hImg, $ImgW, $ImgH
Global $mouse_pos, $draw_pos = -1

$hWnd = GUICreate("Test GDIPlus", $width, $height) ; La fentre
GUISetOnEvent(-3, "_exit")
GUISetState(@SW_SHOW)

Global $USER32_DLL = DllOpen("user32.dll") ; Utile pour les _isPressed()

_GDIPlus_Startup() ; Let's go!
$hGraphic = _GDIPlus_GraphicsCreateFromHWND($hWnd)						; Alors, ces 3 fonctions, j'ai pas trs bien compris ce qu'elle font
$hBitmap = _GDIPlus_BitmapCreateFromGraphics($width, $height, $hGraphic); prcisement, alors je me contente de les utilis comme je vois dans
$hBuffer = _GDIPlus_ImageGetGraphicsContext($hBitmap)					; les scripts de pros!
;~ 																		; Je sais juste que $hBuffer sera le parametre des fonctions de dessins
	_GDIPlus_GraphicsSetSmoothingMode($hBuffer, 2)						; ca, c'est pour l'anti-aliasing

$hImg = _GDIPlus_ImageLoadFromFile("gimp.png")	; On charge l'image
	$ImgW = _GDIPlus_ImageGetWidth($hImg)		; Et on rcupere ses dimensions
	$ImgH = _GDIPlus_ImageGetHeight($hImg)		;

$Brush = _GDIPlus_BrushCreateSolid(0x5500FF00)	; On cre une brosse

While 1
	_GDIPlus_GraphicsClear($hBuffer, 0xFFFFFFFF) 	; On vide le buffer, en lui donnant une couleur blanche
	; ##### START Drawings #####
	If _IsPressed('01', $USER32_DLL) Then 			; Si clique Gauche
		$mouse_pos = MouseGetPos()					; Rcupre les coordon du clique
		Dim $draw_pos[2]							; Transforme la variable $draw_pos en tableau
		$draw_pos[0] = $mouse_pos[0]				; et on lui donne les valeurs du clique
		$draw_pos[1] = $mouse_pos[1]				;
	ElseIf _IsPressed('02', $USER32_DLL) Then		; Si clique Droit
		$draw_pos = -1								; On remet la variable $draw_pos  -1
	EndIf											;

	If IsArray($draw_pos) Then																								; Si $draw_pos est un tableau
		_GDIPlus_GraphicsFillEllipse($hBuffer, $draw_pos[0] - ($ImgW / 2), $draw_pos[1] - ($ImgH / 2), $ImgW, $ImgH, $Brush); on dessine d'abord un cercle vert transparent (c'est les proprites de $Brush)
		_GDIPlus_GraphicsDrawImage($hBuffer, $hImg, $draw_pos[0] - ($ImgW / 2), $draw_pos[1] - ($ImgH / 2))					; puis l'image par dessu
	EndIf
	; ##########
	_GDIPlus_GraphicsDrawImageRect($hGraphic, $hBitmap, 0, 0, $width, $height) ; On copy le graphique $hBuffer dans $hBitmap
	Sleep(30)
WEnd

Func _exit()	; Fonction de sortie (ntoyage des ressources)
	_GDIPlus_ImageDispose($hImg)
	_GDIPlus_PenDispose($Brush)
	_GDIPlus_GraphicsDispose($hBuffer)
	_GDIPlus_BitmapDispose($hBitmap)
	_GDIPlus_GraphicsDispose($hGraphic)
	_GDIPlus_Shutdown()
	Exit
EndFunc
